Name:          raptor
Version:       1.4.21
Release:       2
Summary:       Raptor RDF Parser Toolkit for Redland
Group:         System Environment/Libraries
License:       LGPLv2+ or ASL 2.0
URL:           http://librdf.org/raptor/
Source0:       http://download.librdf.org/source/%{name}-%{version}.tar.gz
Source1:       http://download.librdf.org/source/%{name}-%{version}.tar.gz.asc
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: libxml2-devel >= 2.6.32-2
BuildRequires: libxslt-devel >= 1.1.24-1
BuildRequires: curl-devel >= 7.19.7-1

Requires:      libxml2 >= 2.6.32-2
Requires:      libxslt >= 1.1.24-1
Requires:      curl >= 7.19.7-1

%define _libdir64 %{_prefix}/lib64

%description
Raptor is the RDF Parser Toolkit for Redland that provides
a set of standalone RDF parsers, generating triples from RDF/XML
or N-Triples.

The library is available as 32-bit and 64-bit.


%package       devel
Summary:       Libraries, includes etc to develop with Raptor RDF parser library
Group:         Development/Libraries
Requires:      %{name} = %{version}-%{release}
Requires:      pkg-config

%description   devel
Libraries, includes etc to develop with Raptor RDF parser library.
It provides a set of standalone RDF parsers, generating triples from
RDF/XML or N-Triples.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "xlc -q64" or "gcc -maix64".


%prep
%setup -q
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cp -r 32bit/* 64bit/


%build
export CC="xlc"

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-release
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-release
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
make DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  mv rapper rapper1
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
make DESTDIR=${RPM_BUILD_ROOT} install

# adapt for dual installations together with raptor2
mv ${RPM_BUILD_ROOT}%{_bindir}/rapper ${RPM_BUILD_ROOT}%{_bindir}/rapper1
mv ${RPM_BUILD_ROOT}%{_mandir}/man1/rapper.1 ${RPM_BUILD_ROOT}%{_mandir}/man1/rapper1.1
mv ${RPM_BUILD_ROOT}%{_datadir}/gtk-doc/html/raptor ${RPM_BUILD_ROOT}%{_datadir}/gtk-doc/html/raptor1

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}.so*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc 32bit/AUTHORS 32bit/COPYING 32bit/COPYING.LIB 32bit/ChangeLog
%doc 32bit/LICENSE-2.0.txt 32bit/LICENSE.html 32bit/LICENSE.txt
%doc 32bit/NEWS 32bit/README
%{_bindir}/rapper*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_mandir}/man1/rapper*.1
/usr/bin/rapper*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%defattr(-,root,system)
%doc 32bit/INSTALL.html
%doc %{_datadir}/gtk-doc/html/raptor1/
%{_bindir}/raptor-config*
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/pkgconfig/*
%{_libdir64}/pkgconfig/*
%{_mandir}/man1/raptor-config*.1
%{_mandir}/man3/libraptor.3
/usr/bin/raptor-config*
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%changelog
* Thu Jan 13 2011 Michael Perzl <michael@perzl.org> - 1.4.21-2
- added RTL-style shared libraries
- made it compatible with raptor2 for dual installations

* Mon Feb 01 2010 Michael Perzl <michael@perzl.org> - 1.4.21-1
- updated to version 1.4.21

* Thu Jan 07 2010 Michael Perzl <michael@perzl.org> - 1.4.20-1
- updated to version 1.4.20

* Mon Sep 21 2009 Michael Perzl <michael@perzl.org> - 1.4.19-1
- first version for AIX V5.1 and higher
